Scriptname HSMControllerScript extends LCO_LocationControllerBase

Actor property PlayerRef auto
Message property NotCleared Auto
Message property InCombat Auto
Message property ClaimHSM Auto
int[] property LCO_Indices Auto
int property cancel auto
GlobalVariable property HSM_ControlGlobal auto
GlobalVariable Property MerchantUpdateRate Auto
GlobalVariable Property LCO_IsRunning Auto

Formlist property RadiantExclusionsList Auto
ObjectReference Property BanditControlMarker Auto
ObjectReference Property PrivateControlMarker Auto
ObjectReference Property BattleBornControlMarker Auto
ObjectReference Property GrayManeControlMarker Auto
ObjectReference Property WhiterunControlMarker Auto
ObjectReference Property ImperialControlMarker Auto
ObjectReference Property StormcloakControlMarker Auto
int Control_Whiterun = 1
int Control_Battleborn = 2
int Control_GrayMane = 3 ; numbers from the message indices. here for ease of update if the message change
int Control_Imperial = 4
int Control_Stormcloak = 5
Actor Property Fjori Auto
Actor Property ImperialBackupOverseer Auto
Actor Property StormcloakBackupOverseer Auto
Actor Property WhiterunBackupOverseer Auto

Quest property HSMQuest auto

ObjectReference property enabledBanner auto
ObjectReference nextBanner
ObjectReference[] property banners auto

Event onReset()
	if(HSM_ControlGlobal.getValue() != 0)
		thisLocation.setCleared()
	endIf
endEvent

Event OnActivate(ObjectReference akActionRef)
	if(akActionRef as Actor == PlayerRef)
		if(PlayerRef.isInCombat())
			InCombat.show()
			return
		endIf
		if((thisLocation.getKeywordData(CurrentOwnership) as int == LCO_Bandits && !thisLocation.isCleared()))
			NotCleared.show()
			return
		endIf
	endIf
	int choice = ClaimHSM.show()
	if(choice == cancel)
		return
	endIf
	HSM_ControlGlobal.setValue(choice as float)
	if(choice == Control_Battleborn || choice == Control_GrayMane)
		; idk maybe do some stuff specific to gray mane or battle born in here
	endIf
	int selectedOwner = LCO_Indices[choice]
	updateBanner()
	if(newOwner != selectedOwner)
		newOwner = selectedOwner
		goToState("UpdateQueued")
	endIf
endEvent

Event onLoad()
	updateBanner() ; you know just in case
endEvent

function updateBanner()
	blockActivation()
	int banner = HSM_ControlGlobal.getValue() as int
	int i = banners.length
	while i > 0
		i -= 1
		if(i == banner)
			banners[i].enableNoWait(true)
		else
			banners[i].disableNoWait(true)
		endIf
	endWhile
	blockActivation(false)
endFunction

function enableDisableCorrectOverseerRef(bool enable = true)
	if(!Fjori.isDead() || !enable)
		ImperialBackupOverseer.disableNoWait()
		StormcloakBackupOverseer.disableNoWait()
		WhiterunBackupOverseer.disableNoWait()
		return
	endIf
	int control = HSM_ControlGlobal.getValue() as int
	if(control == Control_Imperial || control == Control_Battleborn)
		ImperialBackupOverseer.enableNoWait()
		StormcloakBackupOverseer.disableNoWait()
		WhiterunBackupOverseer.disableNoWait()
		return
	elseif(control == Control_Stormcloak || control == Control_GrayMane)
		ImperialBackupOverseer.disableNoWait()
		StormcloakBackupOverseer.enableNoWait()
		WhiterunBackupOverseer.disableNoWait()
		return
	elseif(control == Control_Whiterun)
		ImperialBackupOverseer.disableNoWait()
		StormcloakBackupOverseer.disableNoWait()
		WhiterunBackupOverseer.enableNoWait()
		return
	endIf
endFunction

;did someone say OVERRIDE
function updateOwnership()
	int choice = HSM_ControlGlobal.getValue() as int
	if(LCO_IsRunning.getValue() != 0.0)
		parent.updateOwnership();
		if(choice == Control_Battleborn)
			BattleBornControlMarker.enableNoWait()
			GrayManeControlMarker.disableNoWait()
		elseif(choice == Control_GrayMane)
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.enableNoWait()
		else
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.disableNoWait()
		endIf
	else ; basically reproduce lco functionality because you don't have it installed, ugh
		if(choice == 0)
			BanditControlMarker.enableNoWait()
			WhiterunControlMarker.disableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.disableNoWait()
			ImperialControlMarker.disableNoWait()
			StormcloakControlMarker.disableNoWait()
		elseif(choice == Control_Whiterun)
			BanditControlMarker.disableNoWait()
			WhiterunControlMarker.enableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.disableNoWait()
			ImperialControlMarker.disableNoWait()
			StormcloakControlMarker.disableNoWait()
		elseif(choice == Control_Battleborn)
			BanditControlMarker.disableNoWait()
			WhiterunControlMarker.disableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.enableNoWait()
			GrayManeControlMarker.disableNoWait()
			ImperialControlMarker.disableNoWait()
			StormcloakControlMarker.disableNoWait()
		elseif(choice == Control_GrayMane)
			BanditControlMarker.disableNoWait()
			WhiterunControlMarker.disableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.enableNoWait()
			ImperialControlMarker.disableNoWait()
			StormcloakControlMarker.disableNoWait()
		elseif(choice == Control_Imperial)
			BanditControlMarker.disableNoWait()
			WhiterunControlMarker.disableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.disableNoWait()
			ImperialControlMarker.enableNoWait()
			StormcloakControlMarker.disableNoWait()
		elseif(choice == Control_Stormcloak)
			BanditControlMarker.disableNoWait()
			WhiterunControlMarker.disableNoWait()
			PrivateControlMarker.disableNoWait()
			BattleBornControlMarker.disableNoWait()
			GrayManeControlMarker.disableNoWait()
			ImperialControlMarker.disableNoWait()
			StormcloakControlMarker.enableNoWait()
		endIf
		thisLocation.setKeywordData(CurrentOwnership, LCO_Indices[choice])
	endIf
	enableDisableCorrectOverseerRef(false)
	float targetOwner = LCO_Indices[HSM_ControlGlobal.getValue() as int] as float
	while(thisLocation.getKeywordData(CurrentOwnership) != targetOwner)
		Utility.wait(1.0)
	endWhile
	enableDisableCorrectOverseerRef(true)
	HSMQuest.registerForSingleUpdateGameTime(MerchantUpdateRate.getValue())
	updateBanner()
endFunction

function registerMod()
	LCO_MCMScript menuQuest = Game.getForm(0x015f9017) as LCO_MCMScript
	menuQuest.RegisterHaltedStreamMine(realTimeUpdateDelay, gameTimeUpdateDelay, HSM_ControlGlobal, MerchantUpdateRate, HSMQuest)
endFunction